#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#ifndef __CYGWIN__
#pragma weak main
#endif
static char compilerRevision[] = "3929f71a888fe131175684285ef6f3b2ac609a76";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "minigrace";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma DefaultVisibility=public",
  "import \"io\" as io",
  "import \"sys\" as sys",
  "import \"unicode\" as unicode",
  "import \"util\" as util",
  "import \"lexer\" as lexer",
  "import \"ast\" as ast",
  "import \"parser\" as parser",
  "import \"genc\" as genc",
  "import \"genjs\" as genjs",
  "import \"genjson\" as genjson",
  "import \"buildinfo\" as buildinfo",
  "import \"mgcollections\" as mgcollections",
  "import \"interactive\" as interactive",
  "import \"identifierresolution\" as identifierresolution",
  "import \"mirrors\" as mirrors",
  "",
  "util.parseargs",
  "",
  "def targets = [\"lex\", \"parse\", \"grace\", \"processed-ast\", \"patterns\", \"symbols\",",
  "    \"imports\", \"c\", \"js\"]",
  "",
  "if (util.target == \"help\") then {",
  "    print(\"Valid targets:\")",
  "    for (targets) do {t->",
  "        print(\"  {t}\")",
  "    }",
  "    sys.exit(0)",
  "}",
  "",
  "if (util.interactive) then {",
  "    interactive.startRepl",
  "    sys.exit(0)",
  "}",
  "",
  "util.log_verbose \"starting compilation\"",
  "",
  "var tokens := lexer.new.lexfile(util.infile)",
  "if (util.target == \"lex\") then {",
  "    // Print the lexed tokens and quit.",
  "    for (tokens) do { v ->",
  "        if (util.verbosity > 30) then {",
  "            util.outprint \"{v.kind}: {v.value}  [pos: {v.line}.{v.linePos} size: {v.size} indent: {v.indent}]\"",
  "        } else {",
  "            util.outprint \"{v.kind}: {v.value}\"",
  "        }",
  "    }",
  "    util.outfile.close",
  "    sys.exit(0)",
  "}",
  "",
  "// JSON wants to keep hold of the last token in the file",
  "if (util.target == \"json\") then {",
  "    if (tokens.size > 0) then {",
  "        genjson.saveToken(tokens.last)",
  "    }",
  "}",
  "",
  "var values := parser.parse(tokens)",
  "if (util.extensions.contains(\"ClassWrap\")) then {",
  "    def vl = values",
  "    values := []",
  "    def inner = []",
  "    for (vl) do { v->",
  "        if ((v.kind == \"import\") || (v.kind == \"dialect\")) then {",
  "            values.push(v)",
  "        } else {",
  "            inner.push(v)",
  "        }",
  "    }",
  "    values.push(ast.methodNode.new(ast.identifierNode.new(\"new\", false),",
  "        [ast.signaturePart.new(\"new\")],",
  "        [ast.objectNode.new(inner, false)], false))",
  "}",
  "",
  "if (util.target == \"parse\") then {",
  "    // Parse mode pretty-prints the source's AST and quits.",
  "    for (values) do { v ->",
  "        util.outprint(v.pretty(0))",
  "    }",
  "    util.outfile.close",
  "    sys.exit(0)",
  "}",
  "if (util.target == \"grace\") then {",
  "    for (values) do { v ->",
  "        util.outprint(v.toGrace(0))",
  "    }",
  "    util.outfile.close",
  "    sys.exit(0)",
  "}",
  "if (util.target == \"c\") then {",
  "    genc.processImports(values)",
  "}",
  "if (util.target == \"js\") then {",
  "    genjs.processImports(values)",
  "}",
  "if (util.target == \"json\") then {",
  "    genjs.processImports(values)",
  "}",
  "if (util.extensions.contains(\"Plugin\")) then {",
  "    mirrors.loadDynamicModule(util.extensions.get(\"Plugin\")).processAST(values)",
  "}",
  "if (util.target == \"imports\") then {",
  "    def imps = mgcollections.set.new",
  "    def vis = object {",
  "        inherits ast.baseVisitor",
  "        method visitImport(o) -> Boolean {",
  "            imps.add(o.path)",
  "        }",
  "    }",
  "    for (values) do {v->",
  "        v.accept(vis)",
  "    }",
  "    for (imps) do {im->",
  "        util.outprint(im)",
  "    }",
  "    util.outfile.close",
  "    sys.exit(0)",
  "}",
  "values := identifierresolution.resolve(values)",
  "if (util.target == \"processed-ast\") then {",
  "    util.outprint \"=====================================\"",
  "    util.outprint \"module-level symbol table\"",
  "    util.outprint (values.first.parent.symbolTable.asStringWithParents)",
  "    util.outprint \"=====================================\"",
  "    for (values) do { v ->",
  "        util.outprint(v.pretty(0))",
  "    }",
  "    util.outfile.close",
  "    sys.exit(0)",
  "}",
  "",
  "// Perform the actual compilation",
  "match(util.target)",
  "    case { \"c\" ->",
  "        genc.compile(values, util.outfile, util.modname, util.runmode,",
  "            util.buildtype)",
  "    }",
  "    case { \"js\" ->",
  "        genjs.compile(values, util.outfile, util.modname, util.runmode,",
  "            util.buildtype, util.gracelibPath)",
  "    }",
  "    case { \"json\" ->",
  "        genjson.generate(values, util.outfile)",
  "    }",
  "    case { _ ->",
  "        io.error.write(\"minigrace: no such target '\" ++ util.target ++ \"'\\n\")",
  "        sys.exit(1)",
  "    }",
  NULL
};
Object reader_minigrace_outer_347(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object module_io;
Object module_io_init();
Object module_sys;
Object module_sys_init();
Object module_unicode;
Object module_unicode_init();
Object module_util;
Object module_util_init();
Object module_lexer;
Object module_lexer_init();
Object module_ast;
Object module_ast_init();
Object module_parser;
Object module_parser_init();
Object module_genc;
Object module_genc_init();
Object module_genjs;
Object module_genjs_init();
Object module_genjson;
Object module_genjson_init();
Object module_buildinfo;
Object module_buildinfo_init();
Object module_mgcollections;
Object module_mgcollections_init();
Object module_interactive;
Object module_interactive_init();
Object module_identifierresolution;
Object module_identifierresolution_init();
Object module_mirrors;
Object module_mirrors_init();
static Object strlit3;
static Object strlit4;
static Object strlit5;
static Object strlit6;
static Object strlit7;
static Object strlit8;
static Object strlit9;
static Object strlit10;
static Object strlit11;
static Object strlit15;
static Object strlit20;
static Object strlit26;
static Object strlit30;
static Object strlit48;
static Object strlit61;
static Object strlit78;
static Object strlit85;
static Object strlit92;
static Object strlit99;
static Object strlit106;
static Object strlit113;
static Object strlit119;
static Object strlit135;
static Object strlit142;
static Object strlit148;
static Object strlit165;
static Object strlit188;
static Object strlit201;
static Object strlit208;
static Object strlit223;
static Object strlit230;
static Object strlit247;
static Object strlit271;
static Object strlit295;
static Object strlit304;
static Object strlit313;
static Object strlit322;
static Object strlit329;
static Object strlit337;
static ClassData objclass346;
static Object strlit381;
static Object strlit387;
static Object strlit390;
static Object strlit403;
static Object strlit438;
static Object strlit454;
static Object strlit462;
static Object strlit467;
static Object strlit473;
Object meth_minigrace_targets12(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "targets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_targets = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for targets (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹targets›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_targets (depth = 3)
  gc_frame_end(frame);
  return *var_targets;
}
Object meth_minigrace__apply24(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit26 == NULL) {
    strlit26 = alloc_String("");
    gc_root(strlit26);
  }
// compiled string node returning strlit26 (depth = 6)
  int op_slot_right_25 = gc_frame_newslot(strlit26);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  int op_slot_right_28 = gc_frame_newslot(*var_t);
// starting to compile string node (depth = 7)
  if (strlit30 == NULL) {
    strlit30 = alloc_String("  ");
    gc_root(strlit30);
  }
// compiled string node returning strlit30 (depth = 7)
  int op_slot_left_28 = gc_frame_newslot(strlit30);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult31 = callmethod(strlit30, "++", 1, partcv, params);
// compiled op node returning opresult31 (depth = 6)
  int op_slot_left_25 = gc_frame_newslot(opresult31);
  params[0] = strlit26;
  partcv[0] = 1;
  Object opresult32 = callmethod(opresult31, "++", 1, partcv, params);
// compiled op node returning opresult32 (depth = 5)
  params[0] = opresult32;
  Object call33 = gracelib_print(NULL, 1,  params);
// compiled call node returning call33 (depth = 4)
  gc_frame_end(frame);
  return call33;
}
Object meth_minigrace_tokens56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokens (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹tokens›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_minigrace_tokens_58__61_57(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method tokens:=");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokens:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹tokens:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_minigrace__apply68(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num71 = alloc_Float64(30);
// compiled num node returning num71 (depth = 6)
  int op_slot_right_70 = gc_frame_newslot(num71);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe73 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call74 = callmethod(*var_util, "verbosity",
    1, partcv, params);
  gc_frame_end(callframe73);
// compiled call node returning call74 (depth = 7)
// compiled member node returning call74 (depth = 6)
  int op_slot_left_70 = gc_frame_newslot(call74);
  params[0] = num71;
  partcv[0] = 1;
  Object opresult75 = callmethod(call74, ">", 1, partcv, params);
// compiled op node returning opresult75 (depth = 5)
  Object if69 = done;
  if (istrue(opresult75)) {
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe76 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit78 == NULL) {
    strlit78 = alloc_String("]");
    gc_root(strlit78);
  }
// compiled string node returning strlit78 (depth = 7)
  int op_slot_right_77 = gc_frame_newslot(strlit78);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe81 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_v (depth = 10)
  partcv[0] = 0;
  Object call82 = callmethod(*var_v, "indent",
    1, partcv, params);
  gc_frame_end(callframe81);
// compiled call node returning call82 (depth = 9)
// compiled member node returning call82 (depth = 8)
  int op_slot_right_80 = gc_frame_newslot(call82);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit85 == NULL) {
    strlit85 = alloc_String(" indent: ");
    gc_root(strlit85);
  }
// compiled string node returning strlit85 (depth = 9)
  int op_slot_right_84 = gc_frame_newslot(strlit85);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe88 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_v (depth = 12)
  partcv[0] = 0;
  Object call89 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe88);
// compiled call node returning call89 (depth = 11)
// compiled member node returning call89 (depth = 10)
  int op_slot_right_87 = gc_frame_newslot(call89);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit92 == NULL) {
    strlit92 = alloc_String(" size: ");
    gc_root(strlit92);
  }
// compiled string node returning strlit92 (depth = 11)
  int op_slot_right_91 = gc_frame_newslot(strlit92);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe95 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_v (depth = 14)
  partcv[0] = 0;
  Object call96 = callmethod(*var_v, "linePos",
    1, partcv, params);
  gc_frame_end(callframe95);
// compiled call node returning call96 (depth = 13)
// compiled member node returning call96 (depth = 12)
  int op_slot_right_94 = gc_frame_newslot(call96);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit99 == NULL) {
    strlit99 = alloc_String(".");
    gc_root(strlit99);
  }
// compiled string node returning strlit99 (depth = 13)
  int op_slot_right_98 = gc_frame_newslot(strlit99);
// starting to compile op node (depth = 13)
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe102 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_v (depth = 16)
  partcv[0] = 0;
  Object call103 = callmethod(*var_v, "line",
    1, partcv, params);
  gc_frame_end(callframe102);
// compiled call node returning call103 (depth = 15)
// compiled member node returning call103 (depth = 14)
  int op_slot_right_101 = gc_frame_newslot(call103);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit106 == NULL) {
    strlit106 = alloc_String("  [pos: ");
    gc_root(strlit106);
  }
// compiled string node returning strlit106 (depth = 15)
  int op_slot_right_105 = gc_frame_newslot(strlit106);
// starting to compile op node (depth = 15)
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe109 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_v (depth = 18)
  partcv[0] = 0;
  Object call110 = callmethod(*var_v, "value",
    1, partcv, params);
  gc_frame_end(callframe109);
// compiled call node returning call110 (depth = 17)
// compiled member node returning call110 (depth = 16)
  int op_slot_right_108 = gc_frame_newslot(call110);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit113 == NULL) {
    strlit113 = alloc_String(": ");
    gc_root(strlit113);
  }
// compiled string node returning strlit113 (depth = 17)
  int op_slot_right_112 = gc_frame_newslot(strlit113);
// starting to compile op node (depth = 17)
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_v (depth = 20)
  partcv[0] = 0;
  Object call117 = callmethod(*var_v, "kind",
    1, partcv, params);
  gc_frame_end(callframe116);
// compiled call node returning call117 (depth = 19)
// compiled member node returning call117 (depth = 18)
  int op_slot_right_115 = gc_frame_newslot(call117);
// starting to compile string node (depth = 18)
  if (strlit119 == NULL) {
    strlit119 = alloc_String("");
    gc_root(strlit119);
  }
// compiled string node returning strlit119 (depth = 18)
  int op_slot_left_115 = gc_frame_newslot(strlit119);
  params[0] = call117;
  partcv[0] = 1;
  Object opresult120 = callmethod(strlit119, "++", 1, partcv, params);
// compiled op node returning opresult120 (depth = 17)
  int op_slot_left_112 = gc_frame_newslot(opresult120);
  params[0] = strlit113;
  partcv[0] = 1;
  Object opresult121 = callmethod(opresult120, "++", 1, partcv, params);
// compiled op node returning opresult121 (depth = 16)
  int op_slot_left_108 = gc_frame_newslot(opresult121);
  params[0] = call110;
  partcv[0] = 1;
  Object opresult122 = callmethod(opresult121, "++", 1, partcv, params);
// compiled op node returning opresult122 (depth = 15)
  int op_slot_left_105 = gc_frame_newslot(opresult122);
  params[0] = strlit106;
  partcv[0] = 1;
  Object opresult123 = callmethod(opresult122, "++", 1, partcv, params);
// compiled op node returning opresult123 (depth = 14)
  int op_slot_left_101 = gc_frame_newslot(opresult123);
  params[0] = call103;
  partcv[0] = 1;
  Object opresult124 = callmethod(opresult123, "++", 1, partcv, params);
// compiled op node returning opresult124 (depth = 13)
  int op_slot_left_98 = gc_frame_newslot(opresult124);
  params[0] = strlit99;
  partcv[0] = 1;
  Object opresult125 = callmethod(opresult124, "++", 1, partcv, params);
// compiled op node returning opresult125 (depth = 12)
  int op_slot_left_94 = gc_frame_newslot(opresult125);
  params[0] = call96;
  partcv[0] = 1;
  Object opresult126 = callmethod(opresult125, "++", 1, partcv, params);
// compiled op node returning opresult126 (depth = 11)
  int op_slot_left_91 = gc_frame_newslot(opresult126);
  params[0] = strlit92;
  partcv[0] = 1;
  Object opresult127 = callmethod(opresult126, "++", 1, partcv, params);
// compiled op node returning opresult127 (depth = 10)
  int op_slot_left_87 = gc_frame_newslot(opresult127);
  params[0] = call89;
  partcv[0] = 1;
  Object opresult128 = callmethod(opresult127, "++", 1, partcv, params);
// compiled op node returning opresult128 (depth = 9)
  int op_slot_left_84 = gc_frame_newslot(opresult128);
  params[0] = strlit85;
  partcv[0] = 1;
  Object opresult129 = callmethod(opresult128, "++", 1, partcv, params);
// compiled op node returning opresult129 (depth = 8)
  int op_slot_left_80 = gc_frame_newslot(opresult129);
  params[0] = call82;
  partcv[0] = 1;
  Object opresult130 = callmethod(opresult129, "++", 1, partcv, params);
// compiled op node returning opresult130 (depth = 7)
  int op_slot_left_77 = gc_frame_newslot(opresult130);
  params[0] = strlit78;
  partcv[0] = 1;
  Object opresult131 = callmethod(opresult130, "++", 1, partcv, params);
// compiled op node returning opresult131 (depth = 6)
  gc_frame_newslot(opresult131);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  params[0] = opresult131;
  partcv[0] = 1;
  Object call132 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe76);
// compiled call node returning call132 (depth = 5)
    gc_frame_newslot(call132);
    if69 = call132;
  } else {
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe133 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit135 == NULL) {
    strlit135 = alloc_String("");
    gc_root(strlit135);
  }
// compiled string node returning strlit135 (depth = 7)
  int op_slot_right_134 = gc_frame_newslot(strlit135);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_v (depth = 10)
  partcv[0] = 0;
  Object call139 = callmethod(*var_v, "value",
    1, partcv, params);
  gc_frame_end(callframe138);
// compiled call node returning call139 (depth = 9)
// compiled member node returning call139 (depth = 8)
  int op_slot_right_137 = gc_frame_newslot(call139);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit142 == NULL) {
    strlit142 = alloc_String(": ");
    gc_root(strlit142);
  }
// compiled string node returning strlit142 (depth = 9)
  int op_slot_right_141 = gc_frame_newslot(strlit142);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_v (depth = 12)
  partcv[0] = 0;
  Object call146 = callmethod(*var_v, "kind",
    1, partcv, params);
  gc_frame_end(callframe145);
// compiled call node returning call146 (depth = 11)
// compiled member node returning call146 (depth = 10)
  int op_slot_right_144 = gc_frame_newslot(call146);
// starting to compile string node (depth = 10)
  if (strlit148 == NULL) {
    strlit148 = alloc_String("");
    gc_root(strlit148);
  }
// compiled string node returning strlit148 (depth = 10)
  int op_slot_left_144 = gc_frame_newslot(strlit148);
  params[0] = call146;
  partcv[0] = 1;
  Object opresult149 = callmethod(strlit148, "++", 1, partcv, params);
// compiled op node returning opresult149 (depth = 9)
  int op_slot_left_141 = gc_frame_newslot(opresult149);
  params[0] = strlit142;
  partcv[0] = 1;
  Object opresult150 = callmethod(opresult149, "++", 1, partcv, params);
// compiled op node returning opresult150 (depth = 8)
  int op_slot_left_137 = gc_frame_newslot(opresult150);
  params[0] = call139;
  partcv[0] = 1;
  Object opresult151 = callmethod(opresult150, "++", 1, partcv, params);
// compiled op node returning opresult151 (depth = 7)
  int op_slot_left_134 = gc_frame_newslot(opresult151);
  params[0] = strlit135;
  partcv[0] = 1;
  Object opresult152 = callmethod(opresult151, "++", 1, partcv, params);
// compiled op node returning opresult152 (depth = 6)
  gc_frame_newslot(opresult152);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  params[0] = opresult152;
  partcv[0] = 1;
  Object call153 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe133);
// compiled call node returning call153 (depth = 5)
    gc_frame_newslot(call153);
    if69 = call153;
  }
// compiled if node returning if69 (depth = 4)
  gc_frame_end(frame);
  return if69;
}
Object meth_minigrace_values183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹values›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_minigrace_values_58__61_184(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method values:=");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹values:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_minigrace__apply197(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_inner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit201 == NULL) {
    strlit201 = alloc_String("dialect");
    gc_root(strlit201);
  }
// compiled string node returning strlit201 (depth = 7)
  int op_slot_right_200 = gc_frame_newslot(strlit201);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe203 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  partcv[0] = 0;
  Object call204 = callmethod(*var_v, "kind",
    1, partcv, params);
  gc_frame_end(callframe203);
// compiled call node returning call204 (depth = 8)
// compiled member node returning call204 (depth = 7)
  int op_slot_left_200 = gc_frame_newslot(call204);
  params[0] = strlit201;
  partcv[0] = 1;
  Object opresult205 = callmethod(call204, "==", 1, partcv, params);
// compiled op node returning opresult205 (depth = 6)
  int op_slot_right_199 = gc_frame_newslot(opresult205);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit208 == NULL) {
    strlit208 = alloc_String("import");
    gc_root(strlit208);
  }
// compiled string node returning strlit208 (depth = 7)
  int op_slot_right_207 = gc_frame_newslot(strlit208);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  partcv[0] = 0;
  Object call211 = callmethod(*var_v, "kind",
    1, partcv, params);
  gc_frame_end(callframe210);
// compiled call node returning call211 (depth = 8)
// compiled member node returning call211 (depth = 7)
  int op_slot_left_207 = gc_frame_newslot(call211);
  params[0] = strlit208;
  partcv[0] = 1;
  Object opresult212 = callmethod(call211, "==", 1, partcv, params);
// compiled op node returning opresult212 (depth = 6)
  int op_slot_left_199 = gc_frame_newslot(opresult212);
  params[0] = opresult205;
  partcv[0] = 1;
  Object opresult213 = callmethod(opresult212, "||", 1, partcv, params);
// compiled op node returning opresult213 (depth = 5)
  Object if198 = done;
  if (istrue(opresult213)) {
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe214 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call215 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe214);
// compiled call node returning call215 (depth = 5)
    gc_frame_newslot(call215);
    if198 = call215;
  } else {
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe216 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call217 = callmethod(*var_inner, "push",
    1, partcv, params);
  gc_frame_end(callframe216);
// compiled call node returning call217 (depth = 5)
    gc_frame_newslot(call217);
    if198 = call217;
  }
// compiled if node returning if198 (depth = 4)
  gc_frame_end(frame);
  return if198;
}
Object meth_minigrace__apply254(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe255 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe256 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num257 = alloc_Float64(0);
// compiled num node returning num257 (depth = 6)
  gc_frame_newslot(num257);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  params[0] = num257;
  partcv[0] = 1;
  Object call258 = callmethod(*var_v, "pretty",
    1, partcv, params);
  gc_frame_end(callframe256);
// compiled call node returning call258 (depth = 5)
  gc_frame_newslot(call258);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call258;
  partcv[0] = 1;
  Object call259 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe255);
// compiled call node returning call259 (depth = 4)
  gc_frame_end(frame);
  return call259;
}
Object meth_minigrace__apply278(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe279 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe280 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num281 = alloc_Float64(0);
// compiled num node returning num281 (depth = 6)
  gc_frame_newslot(num281);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  params[0] = num281;
  partcv[0] = 1;
  Object call282 = callmethod(*var_v, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe280);
// compiled call node returning call282 (depth = 5)
  gc_frame_newslot(call282);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call282;
  partcv[0] = 1;
  Object call283 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe279);
// compiled call node returning call283 (depth = 4)
  gc_frame_end(frame);
  return call283;
}
Object meth_minigrace_visitImport348(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitImport");
  Object params[1];
  int partcv[1];
  Object *var_imps = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitImport (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitImport");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe349 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe350 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call351 = callmethod(*var_o, "path",
    1, partcv, params);
  gc_frame_end(callframe350);
// compiled call node returning call351 (depth = 6)
// compiled member node returning call351 (depth = 5)
  gc_frame_newslot(call351);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_imps (depth = 5)
  params[0] = call351;
  partcv[0] = 1;
  Object call352 = callmethod(*var_imps, "add",
    1, partcv, params);
  gc_frame_end(callframe349);
// compiled call node returning call352 (depth = 4)
  gc_frame_end(frame);
  return call352;
}
Object meth_minigrace__apply357(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_vis = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe358 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_vis (depth = 5)
  gc_frame_newslot(*var_vis);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  params[0] = *var_vis;
  partcv[0] = 1;
  Object call359 = callmethod(*var_v, "accept",
    1, partcv, params);
  gc_frame_end(callframe358);
// compiled call node returning call359 (depth = 4)
  gc_frame_end(frame);
  return call359;
}
Object meth_minigrace__apply364(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_im = &(stackframe->slots[0]);
  *var_im = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe365 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_im (depth = 5)
  gc_frame_newslot(*var_im);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_im;
  partcv[0] = 1;
  Object call366 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe365);
// compiled call node returning call366 (depth = 4)
  gc_frame_end(frame);
  return call366;
}
Object meth_minigrace__apply407(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe408 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe409 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num410 = alloc_Float64(0);
// compiled num node returning num410 (depth = 6)
  gc_frame_newslot(num410);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  params[0] = num410;
  partcv[0] = 1;
  Object call411 = callmethod(*var_v, "pretty",
    1, partcv, params);
  gc_frame_end(callframe409);
// compiled call node returning call411 (depth = 5)
  gc_frame_newslot(call411);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call411;
  partcv[0] = 1;
  Object call412 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe408);
// compiled call node returning call412 (depth = 4)
  gc_frame_end(frame);
  return call412;
}
Object meth_minigrace__apply426(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_genc = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe427 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call429 = callmethod(*var_util, "outfile",
    1, partcv, params);
  gc_frame_end(callframe428);
// compiled call node returning call429 (depth = 5)
// compiled member node returning call429 (depth = 4)
  gc_frame_newslot(call429);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call431 = callmethod(*var_util, "modname",
    1, partcv, params);
  gc_frame_end(callframe430);
// compiled call node returning call431 (depth = 5)
// compiled member node returning call431 (depth = 4)
  gc_frame_newslot(call431);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe432 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call433 = callmethod(*var_util, "runmode",
    1, partcv, params);
  gc_frame_end(callframe432);
// compiled call node returning call433 (depth = 5)
// compiled member node returning call433 (depth = 4)
  gc_frame_newslot(call433);
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call435 = callmethod(*var_util, "buildtype",
    1, partcv, params);
  gc_frame_end(callframe434);
// compiled call node returning call435 (depth = 5)
// compiled member node returning call435 (depth = 4)
  gc_frame_newslot(call435);
// call case 6: other member request
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_genc (depth = 4)
  params[0] = *var_values;
  params[1] = call429;
  params[2] = call431;
  params[3] = call433;
  params[4] = call435;
  partcv[0] = 5;
  Object call436 = callmethod(*var_genc, "compile",
    1, partcv, params);
  gc_frame_end(callframe427);
// compiled call node returning call436 (depth = 3)
  gc_frame_end(frame);
  return call436;
}
Object meth_minigrace__apply440(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[6];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_genjs = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe441 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe442 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call443 = callmethod(*var_util, "outfile",
    1, partcv, params);
  gc_frame_end(callframe442);
// compiled call node returning call443 (depth = 5)
// compiled member node returning call443 (depth = 4)
  gc_frame_newslot(call443);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call445 = callmethod(*var_util, "modname",
    1, partcv, params);
  gc_frame_end(callframe444);
// compiled call node returning call445 (depth = 5)
// compiled member node returning call445 (depth = 4)
  gc_frame_newslot(call445);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call447 = callmethod(*var_util, "runmode",
    1, partcv, params);
  gc_frame_end(callframe446);
// compiled call node returning call447 (depth = 5)
// compiled member node returning call447 (depth = 4)
  gc_frame_newslot(call447);
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call449 = callmethod(*var_util, "buildtype",
    1, partcv, params);
  gc_frame_end(callframe448);
// compiled call node returning call449 (depth = 5)
// compiled member node returning call449 (depth = 4)
  gc_frame_newslot(call449);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call451 = callmethod(*var_util, "gracelibPath",
    1, partcv, params);
  gc_frame_end(callframe450);
// compiled call node returning call451 (depth = 5)
// compiled member node returning call451 (depth = 4)
  gc_frame_newslot(call451);
// call case 6: other member request
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_genjs (depth = 4)
  params[0] = *var_values;
  params[1] = call443;
  params[2] = call445;
  params[3] = call447;
  params[4] = call449;
  params[5] = call451;
  partcv[0] = 6;
  Object call452 = callmethod(*var_genjs, "compile",
    1, partcv, params);
  gc_frame_end(callframe441);
// compiled call node returning call452 (depth = 3)
  gc_frame_end(frame);
  return call452;
}
Object meth_minigrace__apply456(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_genjson = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe457 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe458 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call459 = callmethod(*var_util, "outfile",
    1, partcv, params);
  gc_frame_end(callframe458);
// compiled call node returning call459 (depth = 5)
// compiled member node returning call459 (depth = 4)
  gc_frame_newslot(call459);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_genjson (depth = 4)
  params[0] = *var_values;
  params[1] = call459;
  partcv[0] = 2;
  Object call460 = callmethod(*var_genjson, "generate",
    1, partcv, params);
  gc_frame_end(callframe457);
// compiled call node returning call460 (depth = 3)
  gc_frame_end(frame);
  return call460;
}
Object meth_minigrace__apply464(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  Object *var_sys = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___0 = &(stackframe->slots[0]);
  *var___0 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe465 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit467 == NULL) {
    strlit467 = alloc_String("'""\x0a""");
    gc_root(strlit467);
  }
// compiled string node returning strlit467 (depth = 5)
  int op_slot_right_466 = gc_frame_newslot(strlit467);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call471 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe470);
// compiled call node returning call471 (depth = 7)
// compiled member node returning call471 (depth = 6)
  int op_slot_right_469 = gc_frame_newslot(call471);
// starting to compile string node (depth = 6)
  if (strlit473 == NULL) {
    strlit473 = alloc_String("minigrace: no such target '");
    gc_root(strlit473);
  }
// compiled string node returning strlit473 (depth = 6)
  int op_slot_left_469 = gc_frame_newslot(strlit473);
  params[0] = call471;
  partcv[0] = 1;
  Object opresult474 = callmethod(strlit473, "++", 1, partcv, params);
// compiled op node returning opresult474 (depth = 5)
  int op_slot_left_466 = gc_frame_newslot(opresult474);
  params[0] = strlit467;
  partcv[0] = 1;
  Object opresult475 = callmethod(opresult474, "++", 1, partcv, params);
// compiled op node returning opresult475 (depth = 4)
  gc_frame_newslot(opresult475);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_io (depth = 6)
  partcv[0] = 0;
  Object call477 = callmethod(*var_io, "error",
    1, partcv, params);
  gc_frame_end(callframe476);
// compiled call node returning call477 (depth = 5)
// compiled member node returning call477 (depth = 4)
  params[0] = opresult475;
  partcv[0] = 1;
  Object call478 = callmethod(call477, "write",
    1, partcv, params);
  gc_frame_end(callframe465);
// compiled call node returning call478 (depth = 3)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe479 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num480 = alloc_Float64(1);
// compiled num node returning num480 (depth = 4)
  gc_frame_newslot(num480);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sys (depth = 4)
  params[0] = num480;
  partcv[0] = 1;
  Object call481 = callmethod(*var_sys, "exit",
    1, partcv, params);
  gc_frame_end(callframe479);
// compiled call node returning call481 (depth = 3)
  gc_frame_end(frame);
  return call481;
}
Object module_minigrace_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(11, 11);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<minigrace>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = grace_prelude();
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[4];
  int partcv[2];
Object *var_io = alloc_var();
Object *var_sys = alloc_var();
Object *var_unicode = alloc_var();
Object *var_util = alloc_var();
Object *var_lexer = alloc_var();
Object *var_ast = alloc_var();
Object *var_parser = alloc_var();
Object *var_genc = alloc_var();
Object *var_genjs = alloc_var();
Object *var_genjson = alloc_var();
Object *var_buildinfo = alloc_var();
Object *var_mgcollections = alloc_var();
Object *var_interactive = alloc_var();
Object *var_identifierresolution = alloc_var();
Object *var_mirrors = alloc_var();
  Object *var_targets = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "targets");
  Object *var_tokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tokens");
  Object *var_values = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "values");
  Object *var_vl = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "vl");
  Object *var_inner = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "inner");
  Object *var_imps = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "imps");
  Object *var_vis = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "vis");
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of sys as sys
  if (module_sys == NULL)
    module_sys = module_sys_init();
  *var_sys = module_sys;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of unicode as unicode
  if (module_unicode == NULL)
    module_unicode = dlmodule("unicode");
  *var_unicode = module_unicode;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = module_util_init();
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of lexer as lexer
  if (module_lexer == NULL)
    module_lexer = module_lexer_init();
  *var_lexer = module_lexer;
// compiled import node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = module_ast_init();
  *var_ast = module_ast;
// compiled import node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of parser as parser
  if (module_parser == NULL)
    module_parser = module_parser_init();
  *var_parser = module_parser;
// compiled import node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of genc as genc
  if (module_genc == NULL)
    module_genc = module_genc_init();
  *var_genc = module_genc;
// compiled import node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of genjs as genjs
  if (module_genjs == NULL)
    module_genjs = module_genjs_init();
  *var_genjs = module_genjs;
// compiled import node returning done (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of genjson as genjson
  if (module_genjson == NULL)
    module_genjson = module_genjson_init();
  *var_genjson = module_genjson;
// compiled import node returning done (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of buildinfo as buildinfo
  if (module_buildinfo == NULL)
    module_buildinfo = module_buildinfo_init();
  *var_buildinfo = module_buildinfo;
// compiled import node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of mgcollections as mgcollections
  if (module_mgcollections == NULL)
    module_mgcollections = module_mgcollections_init();
  *var_mgcollections = module_mgcollections;
// compiled import node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of interactive as interactive
  if (module_interactive == NULL)
    module_interactive = module_interactive_init();
  *var_interactive = module_interactive;
// compiled import node returning done (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of identifierresolution as identifierresolution
  if (module_identifierresolution == NULL)
    module_identifierresolution = module_identifierresolution_init();
  *var_identifierresolution = module_identifierresolution;
// compiled import node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of mirrors as mirrors
  if (module_mirrors == NULL)
    module_mirrors = dlmodule("mirrors");
  *var_mirrors = module_mirrors;
// compiled import node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe0 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  partcv[0] = 0;
  Object call1 = callmethod(*var_util, "parseargs",
    1, partcv, params);
  gc_frame_end(callframe0);
// compiled call node returning call1 (depth = 2)
// compiled member node returning call1 (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 2)
  Object array2 = alloc_BuiltinList();
  gc_pause();
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3 == NULL) {
    strlit3 = alloc_String("lex");
    gc_root(strlit3);
  }
// compiled string node returning strlit3 (depth = 3)
  params[0] = strlit3;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
// starting to compile string node (depth = 3)
  if (strlit4 == NULL) {
    strlit4 = alloc_String("parse");
    gc_root(strlit4);
  }
// compiled string node returning strlit4 (depth = 3)
  params[0] = strlit4;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
// starting to compile string node (depth = 3)
  if (strlit5 == NULL) {
    strlit5 = alloc_String("grace");
    gc_root(strlit5);
  }
// compiled string node returning strlit5 (depth = 3)
  params[0] = strlit5;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
// starting to compile string node (depth = 3)
  if (strlit6 == NULL) {
    strlit6 = alloc_String("processed-ast");
    gc_root(strlit6);
  }
// compiled string node returning strlit6 (depth = 3)
  params[0] = strlit6;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
// starting to compile string node (depth = 3)
  if (strlit7 == NULL) {
    strlit7 = alloc_String("patterns");
    gc_root(strlit7);
  }
// compiled string node returning strlit7 (depth = 3)
  params[0] = strlit7;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
// starting to compile string node (depth = 3)
  if (strlit8 == NULL) {
    strlit8 = alloc_String("symbols");
    gc_root(strlit8);
  }
// compiled string node returning strlit8 (depth = 3)
  params[0] = strlit8;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9 == NULL) {
    strlit9 = alloc_String("imports");
    gc_root(strlit9);
  }
// compiled string node returning strlit9 (depth = 3)
  params[0] = strlit9;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
// starting to compile string node (depth = 3)
  if (strlit10 == NULL) {
    strlit10 = alloc_String("c");
    gc_root(strlit10);
  }
// compiled string node returning strlit10 (depth = 3)
  params[0] = strlit10;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
// starting to compile string node (depth = 3)
  if (strlit11 == NULL) {
    strlit11 = alloc_String("js");
    gc_root(strlit11);
  }
// compiled string node returning strlit11 (depth = 3)
  params[0] = strlit11;
  partcv[0] = 1;
  callmethod(array2, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array2 (depth = 2)
  *var_targets = array2;
  if (array2 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method targets
  block_savedest(self);
  Object closure12 = createclosure(1, "targets");
  setclosureframe(closure12, stackframe);
  addtoclosure(closure12, var_targets);
  struct UserObject *uo12 = (struct UserObject*)self;
  uo12->data[1] = (Object)closure12;
  Method *meth_meth_minigrace_targets12 = addmethod2pos(self, "targets", &meth_minigrace_targets12, 1);
  int argcv_meth_minigrace_targets12[] = {0};
  meth_meth_minigrace_targets12->type = alloc_MethodType(1, argcv_meth_minigrace_targets12);
  meth_meth_minigrace_targets12->definitionModule = modulename;
  meth_meth_minigrace_targets12->definitionLine = 18;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit15 == NULL) {
    strlit15 = alloc_String("help");
    gc_root(strlit15);
  }
// compiled string node returning strlit15 (depth = 3)
  int op_slot_right_14 = gc_frame_newslot(strlit15);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe17 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call18 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe17);
// compiled call node returning call18 (depth = 4)
// compiled member node returning call18 (depth = 3)
  int op_slot_left_14 = gc_frame_newslot(call18);
  params[0] = strlit15;
  partcv[0] = 1;
  Object opresult19 = callmethod(call18, "==", 1, partcv, params);
// compiled op node returning opresult19 (depth = 2)
  Object if13 = done;
  if (istrue(opresult19)) {
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit20 == NULL) {
    strlit20 = alloc_String("Valid targets:");
    gc_root(strlit20);
  }
// compiled string node returning strlit20 (depth = 3)
  params[0] = strlit20;
  Object call21 = gracelib_print(NULL, 1,  params);
// compiled call node returning call21 (depth = 2)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe22 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_targets (depth = 3)
  gc_frame_newslot(*var_targets);
// starting to compile block node (depth = 3)
  Object block23 = alloc_Block(NULL, NULL, "minigrace", 25);
  gc_frame_newslot(block23);
// method _apply
  block_savedest(block23);
  Object closure24 = createclosure(1, "_apply");
  setclosureframe(closure24, stackframe);
  addtoclosure(closure24, selfslot);
  struct UserObject *uo24 = (struct UserObject*)block23;
  uo24->data[0] = (Object)closure24;
  Method *meth_meth_minigrace__apply24 = addmethod2pos(block23, "_apply", &meth_minigrace__apply24, 0);
  int argcv_meth_minigrace__apply24[] = {1};
  meth_meth_minigrace__apply24->type = alloc_MethodType(1, argcv_meth_minigrace__apply24);
  meth_meth_minigrace__apply24->definitionModule = modulename;
  meth_meth_minigrace__apply24->definitionLine = 23;
// compiled block node returning block23 (depth = 3)
  gc_frame_newslot(block23);
// call case 5: prelude request
  params[0] = *var_targets;
  params[1] = block23;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call35 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe22);
// compiled call node returning call35 (depth = 2)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe36 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num37 = alloc_Float64(0);
// compiled num node returning num37 (depth = 3)
  gc_frame_newslot(num37);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sys (depth = 3)
  params[0] = num37;
  partcv[0] = 1;
  Object call38 = callmethod(*var_sys, "exit",
    1, partcv, params);
  gc_frame_end(callframe36);
// compiled call node returning call38 (depth = 2)
    gc_frame_newslot(call38);
    if13 = call38;
  } else {
  }
// compiled if node returning if13 (depth = 1)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe40 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call41 = callmethod(*var_util, "interactive",
    1, partcv, params);
  gc_frame_end(callframe40);
// compiled call node returning call41 (depth = 3)
// compiled member node returning call41 (depth = 2)
  Object if39 = done;
  if (istrue(call41)) {
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe42 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_interactive (depth = 4)
  partcv[0] = 0;
  Object call43 = callmethod(*var_interactive, "startRepl",
    1, partcv, params);
  gc_frame_end(callframe42);
// compiled call node returning call43 (depth = 3)
// compiled member node returning call43 (depth = 2)
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num45 = alloc_Float64(0);
// compiled num node returning num45 (depth = 3)
  gc_frame_newslot(num45);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sys (depth = 3)
  params[0] = num45;
  partcv[0] = 1;
  Object call46 = callmethod(*var_sys, "exit",
    1, partcv, params);
  gc_frame_end(callframe44);
// compiled call node returning call46 (depth = 2)
    gc_frame_newslot(call46);
    if39 = call46;
  } else {
  }
// compiled if node returning if39 (depth = 1)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe47 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit48 == NULL) {
    strlit48 = alloc_String("starting compilation");
    gc_root(strlit48);
  }
// compiled string node returning strlit48 (depth = 2)
  gc_frame_newslot(strlit48);
// call case 6: other member request
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_util (depth = 2)
  params[0] = strlit48;
  partcv[0] = 1;
  Object call49 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe47);
// compiled call node returning call49 (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe50 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe51 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call52 = callmethod(*var_util, "infile",
    1, partcv, params);
  gc_frame_end(callframe51);
// compiled call node returning call52 (depth = 4)
// compiled member node returning call52 (depth = 3)
  gc_frame_newslot(call52);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe53 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lexer (depth = 5)
  partcv[0] = 0;
  Object call54 = callmethod(*var_lexer, "new",
    1, partcv, params);
  gc_frame_end(callframe53);
// compiled call node returning call54 (depth = 4)
// compiled member node returning call54 (depth = 3)
  params[0] = call52;
  partcv[0] = 1;
  Object call55 = callmethod(call54, "lexfile",
    1, partcv, params);
  gc_frame_end(callframe50);
// compiled call node returning call55 (depth = 2)
  *var_tokens = call55;
  if (call55 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method tokens
  block_savedest(self);
  Object closure56 = createclosure(1, "tokens");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_tokens);
  struct UserObject *uo56 = (struct UserObject*)self;
  uo56->data[2] = (Object)closure56;
  Method *meth_meth_minigrace_tokens56 = addmethod2pos(self, "tokens", &meth_minigrace_tokens56, 2);
  int argcv_meth_minigrace_tokens56[] = {0};
  meth_meth_minigrace_tokens56->type = alloc_MethodType(1, argcv_meth_minigrace_tokens56);
  meth_meth_minigrace_tokens56->definitionModule = modulename;
  meth_meth_minigrace_tokens56->definitionLine = 38;
// compiled method node returning  (depth = 2)
// starting to compile method node (depth = 2)
// method tokens:=
  block_savedest(self);
  Object closure57 = createclosure(1, "tokens:=");
  setclosureframe(closure57, stackframe);
  addtoclosure(closure57, var_tokens);
  struct UserObject *uo57 = (struct UserObject*)self;
  uo57->data[3] = (Object)closure57;
  Method *meth_meth_minigrace_tokens_58__61_57 = addmethod2pos(self, "tokens:=", &meth_minigrace_tokens_58__61_57, 3);
  int argcv_meth_minigrace_tokens_58__61_57[] = {1};
  meth_meth_minigrace_tokens_58__61_57->type = alloc_MethodType(1, argcv_meth_minigrace_tokens_58__61_57);
  meth_meth_minigrace_tokens_58__61_57->definitionModule = modulename;
  meth_meth_minigrace_tokens_58__61_57->definitionLine = 38;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit61 == NULL) {
    strlit61 = alloc_String("lex");
    gc_root(strlit61);
  }
// compiled string node returning strlit61 (depth = 3)
  int op_slot_right_60 = gc_frame_newslot(strlit61);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe63 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call64 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe63);
// compiled call node returning call64 (depth = 4)
// compiled member node returning call64 (depth = 3)
  int op_slot_left_60 = gc_frame_newslot(call64);
  params[0] = strlit61;
  partcv[0] = 1;
  Object opresult65 = callmethod(call64, "==", 1, partcv, params);
// compiled op node returning opresult65 (depth = 2)
  Object if59 = done;
  if (istrue(opresult65)) {
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe66 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_newslot(*var_tokens);
// starting to compile block node (depth = 3)
  Object block67 = alloc_Block(NULL, NULL, "minigrace", 41);
  gc_frame_newslot(block67);
// method _apply
  block_savedest(block67);
  Object closure68 = createclosure(2, "_apply");
  setclosureframe(closure68, stackframe);
  addtoclosure(closure68, var_util);
  addtoclosure(closure68, selfslot);
  struct UserObject *uo68 = (struct UserObject*)block67;
  uo68->data[0] = (Object)closure68;
  Method *meth_meth_minigrace__apply68 = addmethod2pos(block67, "_apply", &meth_minigrace__apply68, 0);
  int argcv_meth_minigrace__apply68[] = {1};
  meth_meth_minigrace__apply68->type = alloc_MethodType(1, argcv_meth_minigrace__apply68);
  meth_meth_minigrace__apply68->definitionModule = modulename;
  meth_meth_minigrace__apply68->definitionLine = 39;
// compiled block node returning block67 (depth = 3)
  gc_frame_newslot(block67);
// call case 5: prelude request
  params[0] = *var_tokens;
  params[1] = block67;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call155 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe66);
// compiled call node returning call155 (depth = 2)
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe156 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe157 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call158 = callmethod(*var_util, "outfile",
    1, partcv, params);
  gc_frame_end(callframe157);
// compiled call node returning call158 (depth = 5)
// compiled member node returning call158 (depth = 4)
  partcv[0] = 0;
  Object call159 = callmethod(call158, "close",
    1, partcv, params);
  gc_frame_end(callframe156);
// compiled call node returning call159 (depth = 3)
// compiled member node returning call159 (depth = 2)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe160 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num161 = alloc_Float64(0);
// compiled num node returning num161 (depth = 3)
  gc_frame_newslot(num161);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sys (depth = 3)
  params[0] = num161;
  partcv[0] = 1;
  Object call162 = callmethod(*var_sys, "exit",
    1, partcv, params);
  gc_frame_end(callframe160);
// compiled call node returning call162 (depth = 2)
    gc_frame_newslot(call162);
    if59 = call162;
  } else {
  }
// compiled if node returning if59 (depth = 1)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit165 == NULL) {
    strlit165 = alloc_String("json");
    gc_root(strlit165);
  }
// compiled string node returning strlit165 (depth = 3)
  int op_slot_right_164 = gc_frame_newslot(strlit165);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe167 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call168 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe167);
// compiled call node returning call168 (depth = 4)
// compiled member node returning call168 (depth = 3)
  int op_slot_left_164 = gc_frame_newslot(call168);
  params[0] = strlit165;
  partcv[0] = 1;
  Object opresult169 = callmethod(call168, "==", 1, partcv, params);
// compiled op node returning opresult169 (depth = 2)
  Object if163 = done;
  if (istrue(opresult169)) {
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num172 = alloc_Float64(0);
// compiled num node returning num172 (depth = 4)
  int op_slot_right_171 = gc_frame_newslot(num172);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call175 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe174);
// compiled call node returning call175 (depth = 5)
// compiled member node returning call175 (depth = 4)
  int op_slot_left_171 = gc_frame_newslot(call175);
  params[0] = num172;
  partcv[0] = 1;
  Object opresult176 = callmethod(call175, ">", 1, partcv, params);
// compiled op node returning opresult176 (depth = 3)
  Object if170 = done;
  if (istrue(opresult176)) {
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe177 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call179 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe178);
// compiled call node returning call179 (depth = 5)
// compiled member node returning call179 (depth = 4)
  gc_frame_newslot(call179);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_genjson (depth = 4)
  params[0] = call179;
  partcv[0] = 1;
  Object call180 = callmethod(*var_genjson, "saveToken",
    1, partcv, params);
  gc_frame_end(callframe177);
// compiled call node returning call180 (depth = 3)
    gc_frame_newslot(call180);
    if170 = call180;
  } else {
  }
// compiled if node returning if170 (depth = 2)
    gc_frame_newslot(if170);
    if163 = if170;
  } else {
  }
// compiled if node returning if163 (depth = 1)
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe181 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_newslot(*var_tokens);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_parser (depth = 3)
  params[0] = *var_tokens;
  partcv[0] = 1;
  Object call182 = callmethod(*var_parser, "parse",
    1, partcv, params);
  gc_frame_end(callframe181);
// compiled call node returning call182 (depth = 2)
  *var_values = call182;
  if (call182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method values
  block_savedest(self);
  Object closure183 = createclosure(1, "values");
  setclosureframe(closure183, stackframe);
  addtoclosure(closure183, var_values);
  struct UserObject *uo183 = (struct UserObject*)self;
  uo183->data[4] = (Object)closure183;
  Method *meth_meth_minigrace_values183 = addmethod2pos(self, "values", &meth_minigrace_values183, 4);
  int argcv_meth_minigrace_values183[] = {0};
  meth_meth_minigrace_values183->type = alloc_MethodType(1, argcv_meth_minigrace_values183);
  meth_meth_minigrace_values183->definitionModule = modulename;
  meth_meth_minigrace_values183->definitionLine = 55;
// compiled method node returning  (depth = 2)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method values:=
  block_savedest(self);
  Object closure184 = createclosure(1, "values:=");
  setclosureframe(closure184, stackframe);
  addtoclosure(closure184, var_values);
  struct UserObject *uo184 = (struct UserObject*)self;
  uo184->data[5] = (Object)closure184;
  Method *meth_meth_minigrace_values_58__61_184 = addmethod2pos(self, "values:=", &meth_minigrace_values_58__61_184, 5);
  int argcv_meth_minigrace_values_58__61_184[] = {1};
  meth_meth_minigrace_values_58__61_184->type = alloc_MethodType(1, argcv_meth_minigrace_values_58__61_184);
  meth_meth_minigrace_values_58__61_184->definitionModule = modulename;
  meth_meth_minigrace_values_58__61_184->definitionLine = 55;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe187 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit188 == NULL) {
    strlit188 = alloc_String("ClassWrap");
    gc_root(strlit188);
  }
// compiled string node returning strlit188 (depth = 3)
  gc_frame_newslot(strlit188);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe189 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call190 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe189);
// compiled call node returning call190 (depth = 4)
// compiled member node returning call190 (depth = 3)
  params[0] = strlit188;
  partcv[0] = 1;
  Object call191 = callmethod(call190, "contains",
    1, partcv, params);
  gc_frame_end(callframe187);
// compiled call node returning call191 (depth = 2)
  Object if186 = done;
  if (istrue(call191)) {
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_vl = *var_values;
  if (*var_values == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array192 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array192 (depth = 3)
  *var_values = array192;
  if (array192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array194 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array194 (depth = 3)
  *var_inner = array194;
  if (array194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe195 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vl (depth = 3)
  gc_frame_newslot(*var_vl);
// starting to compile block node (depth = 3)
  Object block196 = alloc_Block(NULL, NULL, "minigrace", 64);
  gc_frame_newslot(block196);
// method _apply
  block_savedest(block196);
  Object closure197 = createclosure(3, "_apply");
  setclosureframe(closure197, stackframe);
  addtoclosure(closure197, var_values);
  addtoclosure(closure197, var_inner);
  addtoclosure(closure197, selfslot);
  struct UserObject *uo197 = (struct UserObject*)block196;
  uo197->data[0] = (Object)closure197;
  Method *meth_meth_minigrace__apply197 = addmethod2pos(block196, "_apply", &meth_minigrace__apply197, 0);
  int argcv_meth_minigrace__apply197[] = {1};
  meth_meth_minigrace__apply197->type = alloc_MethodType(1, argcv_meth_minigrace__apply197);
  meth_meth_minigrace__apply197->definitionModule = modulename;
  meth_meth_minigrace__apply197->definitionLine = 60;
// compiled block node returning block196 (depth = 3)
  gc_frame_newslot(block196);
// call case 5: prelude request
  params[0] = *var_vl;
  params[1] = block196;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call219 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe195);
// compiled call node returning call219 (depth = 2)
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe220 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe221 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe222 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit223 == NULL) {
    strlit223 = alloc_String("new");
    gc_root(strlit223);
  }
// compiled string node returning strlit223 (depth = 5)
  gc_frame_newslot(strlit223);
// starting to compile identifier node (depth = 5)
  Object bool224 = alloc_Boolean(0);
// compiled identifier node returning bool224 (depth = 5)
  gc_frame_newslot(bool224);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call226 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe225);
// compiled call node returning call226 (depth = 6)
// compiled member node returning call226 (depth = 5)
  params[0] = strlit223;
  params[1] = bool224;
  partcv[0] = 2;
  Object call227 = callmethod(call226, "new",
    1, partcv, params);
  gc_frame_end(callframe222);
// compiled call node returning call227 (depth = 4)
  gc_frame_newslot(call227);
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array228 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe229 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit230 == NULL) {
    strlit230 = alloc_String("new");
    gc_root(strlit230);
  }
// compiled string node returning strlit230 (depth = 6)
  gc_frame_newslot(strlit230);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call232 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe231);
// compiled call node returning call232 (depth = 7)
// compiled member node returning call232 (depth = 6)
  params[0] = strlit230;
  partcv[0] = 1;
  Object call233 = callmethod(call232, "new",
    1, partcv, params);
  gc_frame_end(callframe229);
// compiled call node returning call233 (depth = 5)
  params[0] = call233;
  partcv[0] = 1;
  callmethod(array228, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array228 (depth = 4)
  gc_frame_newslot(array228);
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array234 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe235 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  gc_frame_newslot(*var_inner);
// starting to compile identifier node (depth = 6)
  Object bool236 = alloc_Boolean(0);
// compiled identifier node returning bool236 (depth = 6)
  gc_frame_newslot(bool236);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe237 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call238 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe237);
// compiled call node returning call238 (depth = 7)
// compiled member node returning call238 (depth = 6)
  params[0] = *var_inner;
  params[1] = bool236;
  partcv[0] = 2;
  Object call239 = callmethod(call238, "new",
    1, partcv, params);
  gc_frame_end(callframe235);
// compiled call node returning call239 (depth = 5)
  params[0] = call239;
  partcv[0] = 1;
  callmethod(array234, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array234 (depth = 4)
  gc_frame_newslot(array234);
// starting to compile identifier node (depth = 4)
  Object bool240 = alloc_Boolean(0);
// compiled identifier node returning bool240 (depth = 4)
  gc_frame_newslot(bool240);
// call case 6: other member request
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe241 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call242 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe241);
// compiled call node returning call242 (depth = 5)
// compiled member node returning call242 (depth = 4)
  params[0] = call227;
  params[1] = array228;
  params[2] = array234;
  params[3] = bool240;
  partcv[0] = 4;
  Object call243 = callmethod(call242, "new",
    1, partcv, params);
  gc_frame_end(callframe221);
// compiled call node returning call243 (depth = 3)
  gc_frame_newslot(call243);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call243;
  partcv[0] = 1;
  Object call244 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe220);
// compiled call node returning call244 (depth = 2)
    gc_frame_newslot(call244);
    if186 = call244;
  } else {
  }
// compiled if node returning if186 (depth = 1)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit247 == NULL) {
    strlit247 = alloc_String("parse");
    gc_root(strlit247);
  }
// compiled string node returning strlit247 (depth = 3)
  int op_slot_right_246 = gc_frame_newslot(strlit247);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe249 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call250 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe249);
// compiled call node returning call250 (depth = 4)
// compiled member node returning call250 (depth = 3)
  int op_slot_left_246 = gc_frame_newslot(call250);
  params[0] = strlit247;
  partcv[0] = 1;
  Object opresult251 = callmethod(call250, "==", 1, partcv, params);
// compiled op node returning opresult251 (depth = 2)
  Object if245 = done;
  if (istrue(opresult251)) {
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe252 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// starting to compile block node (depth = 3)
  Object block253 = alloc_Block(NULL, NULL, "minigrace", 78);
  gc_frame_newslot(block253);
// method _apply
  block_savedest(block253);
  Object closure254 = createclosure(2, "_apply");
  setclosureframe(closure254, stackframe);
  addtoclosure(closure254, var_util);
  addtoclosure(closure254, selfslot);
  struct UserObject *uo254 = (struct UserObject*)block253;
  uo254->data[0] = (Object)closure254;
  Method *meth_meth_minigrace__apply254 = addmethod2pos(block253, "_apply", &meth_minigrace__apply254, 0);
  int argcv_meth_minigrace__apply254[] = {1};
  meth_meth_minigrace__apply254->type = alloc_MethodType(1, argcv_meth_minigrace__apply254);
  meth_meth_minigrace__apply254->definitionModule = modulename;
  meth_meth_minigrace__apply254->definitionLine = 76;
// compiled block node returning block253 (depth = 3)
  gc_frame_newslot(block253);
// call case 5: prelude request
  params[0] = *var_values;
  params[1] = block253;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call261 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe252);
// compiled call node returning call261 (depth = 2)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe262 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe263 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call264 = callmethod(*var_util, "outfile",
    1, partcv, params);
  gc_frame_end(callframe263);
// compiled call node returning call264 (depth = 5)
// compiled member node returning call264 (depth = 4)
  partcv[0] = 0;
  Object call265 = callmethod(call264, "close",
    1, partcv, params);
  gc_frame_end(callframe262);
// compiled call node returning call265 (depth = 3)
// compiled member node returning call265 (depth = 2)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe266 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num267 = alloc_Float64(0);
// compiled num node returning num267 (depth = 3)
  gc_frame_newslot(num267);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sys (depth = 3)
  params[0] = num267;
  partcv[0] = 1;
  Object call268 = callmethod(*var_sys, "exit",
    1, partcv, params);
  gc_frame_end(callframe266);
// compiled call node returning call268 (depth = 2)
    gc_frame_newslot(call268);
    if245 = call268;
  } else {
  }
// compiled if node returning if245 (depth = 1)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit271 == NULL) {
    strlit271 = alloc_String("grace");
    gc_root(strlit271);
  }
// compiled string node returning strlit271 (depth = 3)
  int op_slot_right_270 = gc_frame_newslot(strlit271);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe273 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call274 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe273);
// compiled call node returning call274 (depth = 4)
// compiled member node returning call274 (depth = 3)
  int op_slot_left_270 = gc_frame_newslot(call274);
  params[0] = strlit271;
  partcv[0] = 1;
  Object opresult275 = callmethod(call274, "==", 1, partcv, params);
// compiled op node returning opresult275 (depth = 2)
  Object if269 = done;
  if (istrue(opresult275)) {
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe276 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// starting to compile block node (depth = 3)
  Object block277 = alloc_Block(NULL, NULL, "minigrace", 85);
  gc_frame_newslot(block277);
// method _apply
  block_savedest(block277);
  Object closure278 = createclosure(2, "_apply");
  setclosureframe(closure278, stackframe);
  addtoclosure(closure278, var_util);
  addtoclosure(closure278, selfslot);
  struct UserObject *uo278 = (struct UserObject*)block277;
  uo278->data[0] = (Object)closure278;
  Method *meth_meth_minigrace__apply278 = addmethod2pos(block277, "_apply", &meth_minigrace__apply278, 0);
  int argcv_meth_minigrace__apply278[] = {1};
  meth_meth_minigrace__apply278->type = alloc_MethodType(1, argcv_meth_minigrace__apply278);
  meth_meth_minigrace__apply278->definitionModule = modulename;
  meth_meth_minigrace__apply278->definitionLine = 84;
// compiled block node returning block277 (depth = 3)
  gc_frame_newslot(block277);
// call case 5: prelude request
  params[0] = *var_values;
  params[1] = block277;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call285 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe276);
// compiled call node returning call285 (depth = 2)
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe286 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call288 = callmethod(*var_util, "outfile",
    1, partcv, params);
  gc_frame_end(callframe287);
// compiled call node returning call288 (depth = 5)
// compiled member node returning call288 (depth = 4)
  partcv[0] = 0;
  Object call289 = callmethod(call288, "close",
    1, partcv, params);
  gc_frame_end(callframe286);
// compiled call node returning call289 (depth = 3)
// compiled member node returning call289 (depth = 2)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe290 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num291 = alloc_Float64(0);
// compiled num node returning num291 (depth = 3)
  gc_frame_newslot(num291);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sys (depth = 3)
  params[0] = num291;
  partcv[0] = 1;
  Object call292 = callmethod(*var_sys, "exit",
    1, partcv, params);
  gc_frame_end(callframe290);
// compiled call node returning call292 (depth = 2)
    gc_frame_newslot(call292);
    if269 = call292;
  } else {
  }
// compiled if node returning if269 (depth = 1)
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit295 == NULL) {
    strlit295 = alloc_String("c");
    gc_root(strlit295);
  }
// compiled string node returning strlit295 (depth = 3)
  int op_slot_right_294 = gc_frame_newslot(strlit295);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe297 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call298 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe297);
// compiled call node returning call298 (depth = 4)
// compiled member node returning call298 (depth = 3)
  int op_slot_left_294 = gc_frame_newslot(call298);
  params[0] = strlit295;
  partcv[0] = 1;
  Object opresult299 = callmethod(call298, "==", 1, partcv, params);
// compiled op node returning opresult299 (depth = 2)
  Object if293 = done;
  if (istrue(opresult299)) {
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe300 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genc (depth = 3)
  params[0] = *var_values;
  partcv[0] = 1;
  Object call301 = callmethod(*var_genc, "processImports",
    1, partcv, params);
  gc_frame_end(callframe300);
// compiled call node returning call301 (depth = 2)
    gc_frame_newslot(call301);
    if293 = call301;
  } else {
  }
// compiled if node returning if293 (depth = 1)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit304 == NULL) {
    strlit304 = alloc_String("js");
    gc_root(strlit304);
  }
// compiled string node returning strlit304 (depth = 3)
  int op_slot_right_303 = gc_frame_newslot(strlit304);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe306 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call307 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe306);
// compiled call node returning call307 (depth = 4)
// compiled member node returning call307 (depth = 3)
  int op_slot_left_303 = gc_frame_newslot(call307);
  params[0] = strlit304;
  partcv[0] = 1;
  Object opresult308 = callmethod(call307, "==", 1, partcv, params);
// compiled op node returning opresult308 (depth = 2)
  Object if302 = done;
  if (istrue(opresult308)) {
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe309 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genjs (depth = 3)
  params[0] = *var_values;
  partcv[0] = 1;
  Object call310 = callmethod(*var_genjs, "processImports",
    1, partcv, params);
  gc_frame_end(callframe309);
// compiled call node returning call310 (depth = 2)
    gc_frame_newslot(call310);
    if302 = call310;
  } else {
  }
// compiled if node returning if302 (depth = 1)
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit313 == NULL) {
    strlit313 = alloc_String("json");
    gc_root(strlit313);
  }
// compiled string node returning strlit313 (depth = 3)
  int op_slot_right_312 = gc_frame_newslot(strlit313);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe315 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call316 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe315);
// compiled call node returning call316 (depth = 4)
// compiled member node returning call316 (depth = 3)
  int op_slot_left_312 = gc_frame_newslot(call316);
  params[0] = strlit313;
  partcv[0] = 1;
  Object opresult317 = callmethod(call316, "==", 1, partcv, params);
// compiled op node returning opresult317 (depth = 2)
  Object if311 = done;
  if (istrue(opresult317)) {
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe318 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genjs (depth = 3)
  params[0] = *var_values;
  partcv[0] = 1;
  Object call319 = callmethod(*var_genjs, "processImports",
    1, partcv, params);
  gc_frame_end(callframe318);
// compiled call node returning call319 (depth = 2)
    gc_frame_newslot(call319);
    if311 = call319;
  } else {
  }
// compiled if node returning if311 (depth = 1)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe321 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit322 == NULL) {
    strlit322 = alloc_String("Plugin");
    gc_root(strlit322);
  }
// compiled string node returning strlit322 (depth = 3)
  gc_frame_newslot(strlit322);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe323 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call324 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe323);
// compiled call node returning call324 (depth = 4)
// compiled member node returning call324 (depth = 3)
  params[0] = strlit322;
  partcv[0] = 1;
  Object call325 = callmethod(call324, "contains",
    1, partcv, params);
  gc_frame_end(callframe321);
// compiled call node returning call325 (depth = 2)
  Object if320 = done;
  if (istrue(call325)) {
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe326 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// call case 6: other member request
// starting to compile call node (depth = 3)
  int callframe327 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe328 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit329 == NULL) {
    strlit329 = alloc_String("Plugin");
    gc_root(strlit329);
  }
// compiled string node returning strlit329 (depth = 5)
  gc_frame_newslot(strlit329);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe330 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call331 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe330);
// compiled call node returning call331 (depth = 6)
// compiled member node returning call331 (depth = 5)
  params[0] = strlit329;
  partcv[0] = 1;
  Object call332 = callmethod(call331, "get",
    1, partcv, params);
  gc_frame_end(callframe328);
// compiled call node returning call332 (depth = 4)
  gc_frame_newslot(call332);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mirrors (depth = 4)
  params[0] = call332;
  partcv[0] = 1;
  Object call333 = callmethod(*var_mirrors, "loadDynamicModule",
    1, partcv, params);
  gc_frame_end(callframe327);
// compiled call node returning call333 (depth = 3)
  params[0] = *var_values;
  partcv[0] = 1;
  Object call334 = callmethod(call333, "processAST",
    1, partcv, params);
  gc_frame_end(callframe326);
// compiled call node returning call334 (depth = 2)
    gc_frame_newslot(call334);
    if320 = call334;
  } else {
  }
// compiled if node returning if320 (depth = 1)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit337 == NULL) {
    strlit337 = alloc_String("imports");
    gc_root(strlit337);
  }
// compiled string node returning strlit337 (depth = 3)
  int op_slot_right_336 = gc_frame_newslot(strlit337);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe339 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call340 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe339);
// compiled call node returning call340 (depth = 4)
// compiled member node returning call340 (depth = 3)
  int op_slot_left_336 = gc_frame_newslot(call340);
  params[0] = strlit337;
  partcv[0] = 1;
  Object opresult341 = callmethod(call340, "==", 1, partcv, params);
// compiled op node returning opresult341 (depth = 2)
  Object if335 = done;
  if (istrue(opresult341)) {
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe342 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mgcollections (depth = 7)
  partcv[0] = 0;
  Object call344 = callmethod(*var_mgcollections, "set",
    1, partcv, params);
  gc_frame_end(callframe343);
// compiled call node returning call344 (depth = 6)
// compiled member node returning call344 (depth = 5)
  partcv[0] = 0;
  Object call345 = callmethod(call344, "new",
    1, partcv, params);
  gc_frame_end(callframe342);
// compiled call node returning call345 (depth = 4)
// compiled member node returning call345 (depth = 3)
  *var_imps = call345;
  if (call345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject346 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj346 = alloc_userobj2(2,4, objclass346);
  gc_frame_newslot(obj346);
// OBJECT OUTER DEC outer
  adddatum2(obj346, self, 0);
  addmethodreal(obj346,"outer", &reader_minigrace_outer_347);
  Object oldself346 = self;
  struct StackFrameObject *oldstackframe346 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe346);
  gc_frame_newslot((Object)stackframe);
  self = obj346;
  Object *oldselfslot346 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter346 = (*(struct UserObject *)self).data[0], lowerouter346 = thisouter346;
  if (inheritingObject346) {
    struct UserObject *inho346 = (struct UserObject *)inheritingObject346;
    while (inho346->super != GraceDefaultObject) inho346 = (struct UserObject *)inho346->super;
    inho346->super = obj346;
    self = inheritingObject346;
    *selfslot = self;
    lowerouter346 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter346;
  }
// method visitImport
  block_savedest(obj346);
  Object closure348 = createclosure(1, "visitImport");
  setclosureframe(closure348, stackframe);
  addtoclosure(closure348, var_imps);
  struct UserObject *uo348 = (struct UserObject*)obj346;
  uo348->data[1] = (Object)closure348;
  Method *meth_meth_minigrace_visitImport348 = addmethod2pos(obj346, "visitImport", &meth_minigrace_visitImport348, 1);
  int argcv_meth_minigrace_visitImport348[] = {1};
  meth_meth_minigrace_visitImport348->type = alloc_MethodType(1, argcv_meth_minigrace_visitImport348);
  meth_meth_minigrace_visitImport348->definitionModule = modulename;
  meth_meth_minigrace_visitImport348->definitionLine = 107;
  sourceObject = obj346;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe353 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call354 = callmethod(*var_ast, "baseVisitor()object",
    2, partcv, params);
  gc_frame_end(callframe353);
// compiled call node returning call354 (depth = 4)
  struct UserObject *obj346_uo = (struct UserObject *)obj346;
  obj346_uo->super = call354;
  sourceObject = obj346;
  objclass346 = obj346->class;
  objclass346->definitionModule = modulename;
  objclass346->definitionLine = 105;
  (*(struct UserObject *)self).data[0] = lowerouter346;
  self = oldself346;
  selfslot = oldselfslot346;
  stackframe = oldstackframe346;
// compiled object node returning obj346 (depth = 3)
  *var_vis = obj346;
  if (obj346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe355 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// starting to compile block node (depth = 3)
  Object block356 = alloc_Block(NULL, NULL, "minigrace", 111);
  gc_frame_newslot(block356);
// method _apply
  block_savedest(block356);
  Object closure357 = createclosure(2, "_apply");
  setclosureframe(closure357, stackframe);
  addtoclosure(closure357, var_vis);
  addtoclosure(closure357, selfslot);
  struct UserObject *uo357 = (struct UserObject*)block356;
  uo357->data[0] = (Object)closure357;
  Method *meth_meth_minigrace__apply357 = addmethod2pos(block356, "_apply", &meth_minigrace__apply357, 0);
  int argcv_meth_minigrace__apply357[] = {1};
  meth_meth_minigrace__apply357->type = alloc_MethodType(1, argcv_meth_minigrace__apply357);
  meth_meth_minigrace__apply357->definitionModule = modulename;
  meth_meth_minigrace__apply357->definitionLine = 108;
// compiled block node returning block356 (depth = 3)
  gc_frame_newslot(block356);
// call case 5: prelude request
  params[0] = *var_values;
  params[1] = block356;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call361 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe355);
// compiled call node returning call361 (depth = 2)
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe362 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_imps (depth = 3)
  gc_frame_newslot(*var_imps);
// starting to compile block node (depth = 3)
  Object block363 = alloc_Block(NULL, NULL, "minigrace", 114);
  gc_frame_newslot(block363);
// method _apply
  block_savedest(block363);
  Object closure364 = createclosure(2, "_apply");
  setclosureframe(closure364, stackframe);
  addtoclosure(closure364, var_util);
  addtoclosure(closure364, selfslot);
  struct UserObject *uo364 = (struct UserObject*)block363;
  uo364->data[0] = (Object)closure364;
  Method *meth_meth_minigrace__apply364 = addmethod2pos(block363, "_apply", &meth_minigrace__apply364, 0);
  int argcv_meth_minigrace__apply364[] = {1};
  meth_meth_minigrace__apply364->type = alloc_MethodType(1, argcv_meth_minigrace__apply364);
  meth_meth_minigrace__apply364->definitionModule = modulename;
  meth_meth_minigrace__apply364->definitionLine = 108;
// compiled block node returning block363 (depth = 3)
  gc_frame_newslot(block363);
// call case 5: prelude request
  params[0] = *var_imps;
  params[1] = block363;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call368 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe362);
// compiled call node returning call368 (depth = 2)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe369 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe370 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call371 = callmethod(*var_util, "outfile",
    1, partcv, params);
  gc_frame_end(callframe370);
// compiled call node returning call371 (depth = 5)
// compiled member node returning call371 (depth = 4)
  partcv[0] = 0;
  Object call372 = callmethod(call371, "close",
    1, partcv, params);
  gc_frame_end(callframe369);
// compiled call node returning call372 (depth = 3)
// compiled member node returning call372 (depth = 2)
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe373 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num374 = alloc_Float64(0);
// compiled num node returning num374 (depth = 3)
  gc_frame_newslot(num374);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sys (depth = 3)
  params[0] = num374;
  partcv[0] = 1;
  Object call375 = callmethod(*var_sys, "exit",
    1, partcv, params);
  gc_frame_end(callframe373);
// compiled call node returning call375 (depth = 2)
    gc_frame_newslot(call375);
    if335 = call375;
  } else {
  }
// compiled if node returning if335 (depth = 1)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe376 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierresolution (depth = 3)
  params[0] = *var_values;
  partcv[0] = 1;
  Object call377 = callmethod(*var_identifierresolution, "resolve",
    1, partcv, params);
  gc_frame_end(callframe376);
// compiled call node returning call377 (depth = 2)
  *var_values = call377;
  if (call377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 1)
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 1)
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit381 == NULL) {
    strlit381 = alloc_String("processed-ast");
    gc_root(strlit381);
  }
// compiled string node returning strlit381 (depth = 3)
  int op_slot_right_380 = gc_frame_newslot(strlit381);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe383 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call384 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe383);
// compiled call node returning call384 (depth = 4)
// compiled member node returning call384 (depth = 3)
  int op_slot_left_380 = gc_frame_newslot(call384);
  params[0] = strlit381;
  partcv[0] = 1;
  Object opresult385 = callmethod(call384, "==", 1, partcv, params);
// compiled op node returning opresult385 (depth = 2)
  Object if379 = done;
  if (istrue(opresult385)) {
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe386 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit387 == NULL) {
    strlit387 = alloc_String("=====================================");
    gc_root(strlit387);
  }
// compiled string node returning strlit387 (depth = 3)
  gc_frame_newslot(strlit387);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit387;
  partcv[0] = 1;
  Object call388 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe386);
// compiled call node returning call388 (depth = 2)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe389 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit390 == NULL) {
    strlit390 = alloc_String("module-level symbol table");
    gc_root(strlit390);
  }
// compiled string node returning strlit390 (depth = 3)
  gc_frame_newslot(strlit390);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit390;
  partcv[0] = 1;
  Object call391 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe389);
// compiled call node returning call391 (depth = 2)
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe392 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe393 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe394 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe395 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe396 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call397 = callmethod(*var_values, "first",
    1, partcv, params);
  gc_frame_end(callframe396);
// compiled call node returning call397 (depth = 10)
// compiled member node returning call397 (depth = 9)
  partcv[0] = 0;
  Object call398 = callmethod(call397, "parent",
    1, partcv, params);
  gc_frame_end(callframe395);
// compiled call node returning call398 (depth = 8)
// compiled member node returning call398 (depth = 7)
  partcv[0] = 0;
  Object call399 = callmethod(call398, "symbolTable",
    1, partcv, params);
  gc_frame_end(callframe394);
// compiled call node returning call399 (depth = 6)
// compiled member node returning call399 (depth = 5)
  partcv[0] = 0;
  Object call400 = callmethod(call399, "asStringWithParents",
    1, partcv, params);
  gc_frame_end(callframe393);
// compiled call node returning call400 (depth = 4)
// compiled member node returning call400 (depth = 3)
  gc_frame_newslot(call400);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call400;
  partcv[0] = 1;
  Object call401 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe392);
// compiled call node returning call401 (depth = 2)
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe402 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit403 == NULL) {
    strlit403 = alloc_String("=====================================");
    gc_root(strlit403);
  }
// compiled string node returning strlit403 (depth = 3)
  gc_frame_newslot(strlit403);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit403;
  partcv[0] = 1;
  Object call404 = callmethod(*var_util, "outprint",
    1, partcv, params);
  gc_frame_end(callframe402);
// compiled call node returning call404 (depth = 2)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe405 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_newslot(*var_values);
// starting to compile block node (depth = 3)
  Object block406 = alloc_Block(NULL, NULL, "minigrace", 126);
  gc_frame_newslot(block406);
// method _apply
  block_savedest(block406);
  Object closure407 = createclosure(2, "_apply");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_util);
  addtoclosure(closure407, selfslot);
  struct UserObject *uo407 = (struct UserObject*)block406;
  uo407->data[0] = (Object)closure407;
  Method *meth_meth_minigrace__apply407 = addmethod2pos(block406, "_apply", &meth_minigrace__apply407, 0);
  int argcv_meth_minigrace__apply407[] = {1};
  meth_meth_minigrace__apply407->type = alloc_MethodType(1, argcv_meth_minigrace__apply407);
  meth_meth_minigrace__apply407->definitionModule = modulename;
  meth_meth_minigrace__apply407->definitionLine = 124;
// compiled block node returning block406 (depth = 3)
  gc_frame_newslot(block406);
// call case 5: prelude request
  params[0] = *var_values;
  params[1] = block406;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call414 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe405);
// compiled call node returning call414 (depth = 2)
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe415 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call417 = callmethod(*var_util, "outfile",
    1, partcv, params);
  gc_frame_end(callframe416);
// compiled call node returning call417 (depth = 5)
// compiled member node returning call417 (depth = 4)
  partcv[0] = 0;
  Object call418 = callmethod(call417, "close",
    1, partcv, params);
  gc_frame_end(callframe415);
// compiled call node returning call418 (depth = 3)
// compiled member node returning call418 (depth = 2)
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe419 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num420 = alloc_Float64(0);
// compiled num node returning num420 (depth = 3)
  gc_frame_newslot(num420);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sys (depth = 3)
  params[0] = num420;
  partcv[0] = 1;
  Object call421 = callmethod(*var_sys, "exit",
    1, partcv, params);
  gc_frame_end(callframe419);
// compiled call node returning call421 (depth = 2)
    gc_frame_newslot(call421);
    if379 = call421;
  } else {
  }
// compiled if node returning if379 (depth = 1)
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 1)
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe423 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call424 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe423);
// compiled call node returning call424 (depth = 3)
// compiled member node returning call424 (depth = 2)
  int frame422 = gc_frame_new();
  gc_frame_newslot(call424);
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block425 = alloc_Block(NULL, NULL, "minigrace", 135);
  gc_frame_newslot(block425);
// method _apply
  block_savedest(block425);
  Object closure426 = createclosure(4, "_apply");
  setclosureframe(closure426, stackframe);
  addtoclosure(closure426, var_values);
  addtoclosure(closure426, var_util);
  addtoclosure(closure426, var_genc);
  addtoclosure(closure426, selfslot);
  struct UserObject *uo426 = (struct UserObject*)block425;
  uo426->data[0] = (Object)closure426;
  Method *meth_meth_minigrace__apply426 = addmethod2pos(block425, "_apply", &meth_minigrace__apply426, 0);
  int argcv_meth_minigrace__apply426[] = {0};
  meth_meth_minigrace__apply426->type = alloc_MethodType(1, argcv_meth_minigrace__apply426);
  meth_meth_minigrace__apply426->definitionModule = modulename;
  meth_meth_minigrace__apply426->definitionLine = 134;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit438 == NULL) {
    strlit438 = alloc_String("c");
    gc_root(strlit438);
  }
// compiled string node returning strlit438 (depth = 3)
((struct UserObject *)block425)->data[1] = strlit438;
// compiled block node returning block425 (depth = 2)
  gc_frame_newslot(block425);
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block439 = alloc_Block(NULL, NULL, "minigrace", 139);
  gc_frame_newslot(block439);
// method _apply
  block_savedest(block439);
  Object closure440 = createclosure(4, "_apply");
  setclosureframe(closure440, stackframe);
  addtoclosure(closure440, var_values);
  addtoclosure(closure440, var_util);
  addtoclosure(closure440, var_genjs);
  addtoclosure(closure440, selfslot);
  struct UserObject *uo440 = (struct UserObject*)block439;
  uo440->data[0] = (Object)closure440;
  Method *meth_meth_minigrace__apply440 = addmethod2pos(block439, "_apply", &meth_minigrace__apply440, 0);
  int argcv_meth_minigrace__apply440[] = {0};
  meth_meth_minigrace__apply440->type = alloc_MethodType(1, argcv_meth_minigrace__apply440);
  meth_meth_minigrace__apply440->definitionModule = modulename;
  meth_meth_minigrace__apply440->definitionLine = 137;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit454 == NULL) {
    strlit454 = alloc_String("js");
    gc_root(strlit454);
  }
// compiled string node returning strlit454 (depth = 3)
((struct UserObject *)block439)->data[1] = strlit454;
// compiled block node returning block439 (depth = 2)
  gc_frame_newslot(block439);
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block455 = alloc_Block(NULL, NULL, "minigrace", 143);
  gc_frame_newslot(block455);
// method _apply
  block_savedest(block455);
  Object closure456 = createclosure(4, "_apply");
  setclosureframe(closure456, stackframe);
  addtoclosure(closure456, var_values);
  addtoclosure(closure456, var_util);
  addtoclosure(closure456, var_genjson);
  addtoclosure(closure456, selfslot);
  struct UserObject *uo456 = (struct UserObject*)block455;
  uo456->data[0] = (Object)closure456;
  Method *meth_meth_minigrace__apply456 = addmethod2pos(block455, "_apply", &meth_minigrace__apply456, 0);
  int argcv_meth_minigrace__apply456[] = {0};
  meth_meth_minigrace__apply456->type = alloc_MethodType(1, argcv_meth_minigrace__apply456);
  meth_meth_minigrace__apply456->definitionModule = modulename;
  meth_meth_minigrace__apply456->definitionLine = 141;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit462 == NULL) {
    strlit462 = alloc_String("json");
    gc_root(strlit462);
  }
// compiled string node returning strlit462 (depth = 3)
((struct UserObject *)block455)->data[1] = strlit462;
// compiled block node returning block455 (depth = 2)
  gc_frame_newslot(block455);
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block463 = alloc_Block(NULL, NULL, "minigrace", 146);
  gc_frame_newslot(block463);
// method _apply
  block_savedest(block463);
  Object closure464 = createclosure(4, "_apply");
  setclosureframe(closure464, stackframe);
  addtoclosure(closure464, var_util);
  addtoclosure(closure464, var_io);
  addtoclosure(closure464, var_sys);
  addtoclosure(closure464, selfslot);
  struct UserObject *uo464 = (struct UserObject*)block463;
  uo464->data[0] = (Object)closure464;
  Method *meth_meth_minigrace__apply464 = addmethod2pos(block463, "_apply", &meth_minigrace__apply464, 0);
  int argcv_meth_minigrace__apply464[] = {1};
  meth_meth_minigrace__apply464->type = alloc_MethodType(1, argcv_meth_minigrace__apply464);
  meth_meth_minigrace__apply464->definitionModule = modulename;
  meth_meth_minigrace__apply464->definitionLine = 144;
// compiled block node returning block463 (depth = 2)
  gc_frame_newslot(block463);
  params[0] = block425;
  params[1] = block439;
  params[2] = block455;
  params[3] = block463;
  Object matchres422 = matchCase(call424, params, 4,NULL);
  gc_frame_end(frame422);
// compiled matchcase node returning matchres422 (depth = 1)
  gc_frame_end(frame);
  return self;
}
int main(int argc, char **argv) {
  initprofiling();
  setCompilerModulePath("/Users/black/Development/mg/apb/minigrace");
  setModulePath("/usr/lib/grace/modules");
  gracelib_argv(argv);
  Object params[1];
  undefined = alloc_Undefined();
  done = alloc_done();
  Object tmp_argv = alloc_BuiltinList();
  gc_root(tmp_argv);
  int partcv_push[] = {1};
  int i; for (i=0; i<argc; i++) {
    params[0] = alloc_String(argv[i]);
    callmethod(tmp_argv, "push", 1, partcv_push, params);
  }
  module_sys_init_argv(tmp_argv);
  module_minigrace_init();
  gracelib_stats();
  return 0;
}
